extends ViewportContainer

export var rotation_speed : float = 0.25
export var pan_speed : float = 0.002
export var zoom_speed : float = 0.15
var rotating = false

onready var camera_origin : Spatial = get_node("Viewport/Spatial/Spatial")

func _ready():
	VisualServer.set_debug_generate_wireframes(true)

func _gui_input(event : InputEvent) -> void:
	if (event is InputEventMouse):
		if(Input.is_action_pressed("zoom_in") && camera_origin.get_node("Camera").translation.length() > 0.1):
			camera_origin.get_node("Camera").translation -= camera_origin.get_node("Camera").translation * zoom_speed
		elif(Input.is_action_pressed("zoom_out")):
			camera_origin.get_node("Camera").translation += camera_origin.get_node("Camera").translation * zoom_speed
		if(Input.is_action_just_pressed("rotate_camera") || Input.is_action_just_pressed("pan_camera")):
			rotating = true

func _input(event : InputEvent) -> void:
	if(rotating):
		if(event is InputEventMouseMotion):
			var relative : Vector2 = event.relative
			if(relative.x <= -rect_size.x):
				relative.x += rect_size.x
			elif(relative.x >= rect_size.x):
				relative.x -= rect_size.x
			if(relative.y <= -rect_size.y):
				relative.y += rect_size.y
			elif(relative.y >= rect_size.y):
				relative.y -= rect_size.y
			var new_pos : Vector2 = event.global_position - rect_global_position
			var rect_end : Vector2 = rect_global_position + rect_size
			if(event.position.x < rect_global_position.x):
				new_pos.x = rect_size.x + event.position.x - rect_global_position.x
			elif(event.position.x > rect_end.x):
				new_pos.x = event.position.x - rect_end.x
			if(event.position.y < rect_global_position.y):
				new_pos.y = rect_size.y + event.position.y - rect_global_position.y
			elif(event.position.y > rect_end.y):
				new_pos.y = event.position.y - rect_end.y
			if(new_pos != event.global_position - rect_global_position):
				warp_mouse(new_pos)
			if(Input.is_action_pressed("pan_camera") && Input.is_action_pressed("pan_modifier")):
				var scale : float = camera_origin.get_node("Camera").global_transform.origin.length()
				camera_origin.translate((scale * Vector3.UP * relative.y + scale * Vector3.RIGHT * -relative.x) * pan_speed)
			elif(Input.is_action_pressed("rotate_camera")):
				camera_origin.rotation_degrees.x -= relative.y * rotation_speed
				camera_origin.rotation_degrees.y -= relative.x * rotation_speed
				camera_origin.rotation_degrees.x = wrapf(camera_origin.rotation_degrees.x, -180, 180)
				camera_origin.rotation_degrees.y = wrapf(camera_origin.rotation_degrees.y, -180, 180)
			else:
				rotating = false
